#
# spec file for package ltrace (Version 0.3.36)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libelf libgcc libnscd libstdc++ libstdc++-devel libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel

Name:           ltrace
BuildRequires:  libelf libstdc++-devel
URL:            http://packages.debian.org/unstable/utils/ltrace.html
License:        GPL
Group:          Development/Tools/Debuggers
Autoreqprov:    on
Summary:        Trace the Library and System Calls a Program Makes
Version:        0.3.36
Release:        21.6
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source:         ftp://ftp.debian.org/debian/pool/main/l/ltrace/%{name}_%{version}.orig.tar.gz
Source1:        ltrace-acl+xattr.conf
Patch:          ltrace-0.3.36-gelf_h.diff
Patch1:         ltrace-0.3.36-package_version.diff
Patch2:         ltrace-debug.diff
Patch3:         ltrace-biarch.diff
Patch4:         ltrace-use_ppc_for_ppc64.diff
Patch5:         ltrace-basic_ppc64.diff
Patch6:         ltrace-break_on_global.diff
Patch7:         ltrace-connect_breakpoint_to_libsym.diff
Patch8:         ltrace-break_at_main_for_uninitialized_PLTs.diff
Patch9:         ltrace-indirect_PLTs.diff
Patch10:        ltrace-fix_-p_bug.diff
Patch11:        ltrace-s390x.diff
Patch12:        ltrace-biarch.patch
Patch13:        ltrace-no_segfault_on_fork.diff
Patch14:        ltrace-ppc_secure_PLTs.diff
Patch15:        ltrace.man.patch
ExclusiveArch: %ix86 sparc s390 s390x ppc ppc64 armv4l x86_64 alpha
Prefix:         /usr

%description
Ltrace is a program that runs the specified command until it exits. It
intercepts and records the dynamic library calls that are called by the
executed process and the signals that are received by that process. It
can also intercept and print the system calls executed by the program.

The program to trace need not be recompiled for this, so you can use
ltrace on binaries for which you do not have access to the source.

This is still a work in progress, so, for example, the tracking to
child processes may fail or some things may not work as expected.



Authors:
--------
    Juan Cespedes

%debug_package
%prep
%setup -q
%patch
%patch1
%patch2
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
# ltrace-fix_-p_bug.diff has a side effect which causes a regression
# for non-ppc archs. What it addresses works on all other archs
# and ltrace mainline does things better than this patch. This patch
# is only a kludge which only helps on ppc/ppc64, and even there,
# it's not getting it done as it should, and it hurts all others.
# See the header of the patch and bug 138568 for more information:
%ifarch ppc ppc64 
%patch10 -p1
%endif
%patch11
%patch12 -p1
%patch13
%patch14 -p1
%patch15 -p1
test -f etc/ltrace.conf || exit 1
cat %{S:1} >> etc/ltrace.conf

%build
autoreconf -fi
export CFLAGS="%{optflags} -W -Wall"
./configure --prefix=/usr \
	    --sysconfdir=/etc \
	    --mandir=%{_mandir} \
%ifarch armv4l
	--target=arm-suse-linux
%else
	--target=%{_target_cpu}-suse-linux
%endif
make

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
rm -rf %{buildroot}/usr/doc/ltrace

%files
%defattr(-,root,root)
%doc COPYING README TODO BUGS ChangeLog
%{_bindir}/ltrace
%{_mandir}/man1/ltrace.1.gz
%config /etc/ltrace.conf

%changelog -n ltrace
* Tue May 30 2006 - bk@suse.de
- fix crash of every process traced with -p on ltrace exit (138568)
* Thu May 18 2006 - olh@suse.de
- update man page to ltrace 0.4 version (176209 - LTC23913)
* Tue May 02 2006 - olh@suse.de
- add handling for secure PLT on powerpc (154472 - LTC21994)
  fix segfault when following forks (155754 - LTC22229)
  configure does checks for c++ features, add c++ to Buildrequires
* Mon Mar 20 2006 - pth@suse.de
- Add patch from IBM that fixes segfaults when using -x (#150487)
* Thu Mar 02 2006 - hare@suse.de
- biarch support for S/390.
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Jun 28 2005 - uli@suse.de
- ported s390x support from 0.3.10
* Tue May 10 2005 - pth@suse.de
- Incorporate RH patch for biarch support
- Incorporate all pathches from IBM for biarch ltrace on ppc64
* Thu Apr 21 2005 - pth@suse.de
- Fix warnings in the ppc specific parts.
* Thu Apr 14 2005 - pth@suse.de
- Don't use elfutils because of their unacceptable license,
  use libelf instead.
- Fix the check for gelf.h
- Really use the include path for gelf.h that configure found.
- Use version number from config.h
* Mon Apr 04 2005 - pth@suse.de
- Update to ltrace 0.3.36:
- All SUSE patches integrated
- Alpha support,
- Uses elfutils.
- list of functions expanded.
* Thu Mar 24 2005 - pth@suse.de
- Adapt patch from Jakub Jellinek to make ltrace handle long/ulong
  values and thus work on AMD64 (#74374).
* Fri May 07 2004 - bk@suse.de
- fix assert in call summary if ltrace was tracing nothing(#39642)
* Thu Apr 01 2004 - bk@suse.de
- use new path for changelog file, fixes stale symlink (Bug #36383)
- update manual page regarding bugs fixed with the applied patches
* Wed Mar 31 2004 - bk@suse.de
- calculate PLT table function address if missing in symtab(#36212)
  (this makes ltrace work again on i386, otherwise it does nothing)
* Mon Feb 23 2004 - bk@suse.de
- Update to ltrace 0.3.31: More functions in ltrace.conf, options
  to show time spent inside each call and summary of calls at end
* Mon Feb 09 2004 - bk@suse.de
- fix ExclusiveArch: Include s390 and s390x for 32- and 64-bit arch
* Fri Jun 13 2003 - mmj@suse.de
- Use BuildRoot
* Mon Jun 02 2003 - ro@suse.de
- remove unpackaged files from buildroot
* Fri Sep 20 2002 - agruen@suse.de
- Update syscall table definitions for supported architectures to
  current 8.1/UL/SLES kernel.
- Add declarations for extended attribute syscalls and
  for libacl functions (POSIX ACL library).
* Fri Jul 12 2002 - kukuk@suse.de
- Fix ExclusiveArch for x86.
* Thu Jun 27 2002 - mludvig@suse.cz
- Added support for Elf64 binaries.
- Fixed x86-64 port.
* Fri Jun 07 2002 - aj@suse.de
- Update to ltrace 0.3.26:
  * Added support for s390 and powerpc
- Add initial support for x86-64.
* Mon Nov 26 2001 - uli@suse.de
- added armv4l to ExclusiveArch
* Thu Jul 19 2001 - uli@suse.de
- added PPC port by Anton Blanchard
* Tue Apr 03 2001 - bk@suse.de
- added S/390 patch from IBM Linux Technology Center
* Mon Jan 10 2000 - kukuk@suse.de
- Update to ltrace 0.3.10
- Add patch for SPARC
* Sat Oct 23 1999 - bk@suse.de
- updated to ltrace-0.3.8
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Wed Aug 04 1999 - bs@suse.de
- added call of Check
* Mon Mar 29 1999 - bk@suse.de
- new package
